void button();
void setup() {
  // put your setup code here, to run once:
  pinMode(PIN_PA6, OUTPUT);
  pinMode(PIN_PA3, INPUT_PULLUP);
}

void loop() {
  // put your main code here, to run repeatedly:
  for (uint8_t pwm = 0; pwm < 150; pwm++) {
    analogWrite(PIN_PA6, pwm);
    delay(10);
    if (!digitalRead(PIN_PA3)) {
      button();
    }
  }
  for (uint8_t pwm = 150; pwm > 0; pwm--) {
    analogWrite(PIN_PA6, pwm);
    delay(10);
    if (!digitalRead(PIN_PA3)) {
      button();
    }
  }
}
void button() {
  bool state = 1;
  while (1) {
    digitalWrite(PIN_PA6, state);  //led on
    uint32_t time = millis();
    while (!digitalRead(PIN_PA3)) {
      if (millis() - time > 1000) {
        state ^= 1;
        digitalWrite(PIN_PA6, state);
        while (!digitalRead(PIN_PA3))
          ;  //wait for rel
        delay(10);
        return;
      }

    }            //wait for rel
    delay(100);  //debounce
    while (digitalRead(PIN_A3))
      ;  //wait for press
    state ^= 1;
    delay(100);  //debounce
  }
}